'From Smalltalk/X, Version:2.10.4 on 8-mar-1995 at 11:31:10'!

Array subclass:#IndexedTable
	 instanceVariableNames:'lowBound hiBound'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Collections-Arrayed'
!

!IndexedTable class methodsFor:'documentation'!

version
"
$Header: /claus/smalltalk/st/goodies/RCS/Collections-IndexedTable.st,v 1.1 95/03/09 02:17:44 claus Exp $
"
!

documentation
"
    An indexedTable is like an Array, but allows arbitrary integer
    start- and end indices (instead of 1 .. n).
    After creation with:

        myTable := IndexedTable from:-5 to:5.

    you can access elements as:

        myTable at:-5 put:5.
        myTable at:5 put:-5.

    other than that, they behave like arrays.

    This is a simple demo only; currently not used in the system.
"
!

examples
"
    examples to be added.
"
! !

!IndexedTable class methodsFor:'instance creation'!

from:low to:hi
    ^ (super new:(hi - low + 1)) setLowBound:low hiBound:hi 
!

new:n
    ^ (super new:n) setLowBound:1 hiBound:n
! !

!IndexedTable methodsFor:'private accessing'!

setLowBound:low hiBound:hi
    lowBound := low.
    hiBound := hi
! !

!IndexedTable methodsFor:'accessing'!

at:index put:something
    ^ super at:(index - lowBound + 1) put:something
!

at:index
    ^ super at:(index - lowBound + 1)
!

keys
    ^ lowBound to:hiBound
! !

