"
 claus:

 this class has been extracted from a Manchester Goodies Benchmark package -
 it may be useful on its own.
 credit goes to:

	NAME            Benchmarks
	AUTHOR          SW@cs.man.ac.uk
	FUNCTION timing analysis and comparison: makes tables, diagrams 
	ST-VERSIONS     2.2
	PREREQUISITES    
	CONFLICTS       
	DISTRIBUTION    world
	VERSION         1.1
	DATE    22 Jan 1989
SUMMARY Benchmarks
	provides facilities for timing benchmarks and analysing
	the proportion of time spent within specified methods (copes
	with recursive code, unlike spyOn:).  Information is shown in
	a table or diagram.  Facilities are provided to compare different
	versions of similar code. (2.2). SW
"
!

Collection subclass: #MultiDimensionalArray
	instanceVariableNames: 'data dimensions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Benchmarks'!
MultiDimensionalArray comment:
'A general facility for an array with fixed dimensions.  The indices can be any
 objects; they need not be integers.
'!


!MultiDimensionalArray methodsFor: 'initialize-release'!

subscripts: anArray fill: default
	"Set the subscripts to those in anArray, and fill the array."

	dimensions := anArray size.
	data := self createFrom: anArray index: 1 fill: default! !

!MultiDimensionalArray methodsFor: 'accessing'!

at: anArray
	"Get the element determined by subscript 'anArray'."

	| r |
	dimensions = anArray size ifFalse: [self error: 'Bad subscript'].
	r := data.
	anArray do: [:sub | r := r at: sub].
	^r!

at: anArray incrementBy: num
	"Increment by 'num' the element determined by subscript 'anArray'."

	| r |
	dimensions = anArray size ifFalse: [self error: 'Bad subscript'].
	dimensions = 0
		ifTrue: [^data := data + num]
		ifFalse: 
			[r := data.
			1 to: anArray size - 1 do: [:index | r := r at: (anArray at: index)].
			^r at: anArray last put: (r at: anArray last) + num]!

at: anArray put: element
	"Set the element determined by subscript 'anArray'."

	| r |
	dimensions = anArray size ifFalse: [self error: 'Bad subscript'].
	dimensions = 0
		ifTrue: [^data := element]
		ifFalse: 
			[r := data.
			1 to: anArray size - 1 do: [:index | r := r at: (anArray at: index)].
			^r at: anArray last put: element]! !

!MultiDimensionalArray methodsFor: 'adding'!

add: el
	self shouldNotImplement! !

!MultiDimensionalArray methodsFor: 'removing'!

remove: el ifAbsent: aBlock
	self shouldNotImplement! !

!MultiDimensionalArray methodsFor: 'enumerating'!

associationsDo: aBlock
	"Perform aBlock for all (index-element) combinations."

	self associationsDo: aBlock data: data sub: (Array new: dimensions) index: 1!


do: aBlock
	"Perform aBlock for all elements."

	self associationsDo: [:assoc | aBlock value: assoc value]! !

!MultiDimensionalArray methodsFor: 'printing'!

printOn: aStream 
	"Print the information in the array."

	self class printOn: aStream.
	aStream nextPutAll: ' ('.
	self
		associationsDo: 
			[:assoc | 
			assoc printOn: aStream.
			aStream space]
		data: data
		sub: (Array new: dimensions)
		index: 1.
	aStream nextPut: $)! !

!MultiDimensionalArray methodsFor: 'private'!

associationsDo: aBlock data: info sub: sub index: index 
	index > dimensions
		ifTrue: 
			[aBlock value: (Association key: sub value: info)]
		ifFalse: [info class == Array
				ifTrue: [1 to: info size do: 
						[:ind | 
						sub at: index put: ind.
						self
							associationsDo: aBlock
							data: (info at: ind)
							sub: sub
							index: index + 1]]
				ifFalse: [info
						associationsDo: 
							[:assoc | 
							sub at: index put: assoc key.
							self
								associationsDo: aBlock
								data: assoc value
								sub: sub
								index: index + 1]]]!

createFrom: anArray index: anInteger fill: default
	| sub r |
	anArray size < anInteger ifTrue: [^default].
	sub := anArray at: anInteger.
	r := sub = (1 to: sub size)
				ifTrue: [Array new: sub size]
				ifFalse: [Dictionary new].
	sub do: [:subscript | r at: subscript put: (self createFrom: anArray index:
 anInteger + 1 fill: default)].
	^r! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MultiDimensionalArray class
	instanceVariableNames: ''!


!MultiDimensionalArray class methodsFor: 'instance creation'!

new
	"Create a zero-dimensional array."

	^self new: #()!

new: anArray
	"Create a new multidimensional array defined by anArray of subscripts."

	"MultiDimensionalArray new: (Array with: (1 to: 3) with: #(a b c))."

	^super new subscripts: anArray fill: nil!

new: anArray withAll: element
	"Create a new multidimensional array filled with 'element'."

	^super new subscripts: anArray fill: element! !

"COPYRIGHT.
 The above file is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).
 Further information on the copyright conditions may be obtained by
 sending electronic mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1992 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help 
"!

