"       NAME            SetArithmetic
	AUTHOR          Ifor Wyn Williams <ifor@cs.man.ac.uk>
	FUNCTION set operators: intersect, union, =, etc 
	ST-VERSIONS     2.3 2.4 2.5 4.0 4.1 X2.5
	PREREQUISITES    
	CONFLICTS       
	DISTRIBUTION    world
	VERSION         1.2
	DATE    10 Sep 1991
SUMMARY SetArithmetic
	Simple set arithmetic and comparison operators, e.g.
	intersection, union, difference, subsets, equality, etc.
"!

!Set methodsFor: 'arithmetic'!

& aSet 
	"Set intersection."

	| intersectionSet |
	intersectionSet := self species new.
	self size < aSet size
		ifTrue: [self do: [:elem | (aSet includes: elem)
					ifTrue: [intersectionSet add: elem]]]
		ifFalse: [aSet do: [:elem | (self includes: elem)
					ifTrue: [intersectionSet add: elem]]].
	^intersectionSet!

+ aSet 
	"Set union."

	| unionSet |
	unionSet := self species new.
	unionSet addAll: self.
	unionSet addAll: aSet.
	^unionSet!

- aSet
	"Set difference."

	| differenceSet |
	differenceSet := self species new.
	self do: [:elem | (aSet includes: elem)
		ifFalse: [differenceSet add: elem]].
	^differenceSet! !

!Set methodsFor: 'comparing'!

< aSet 
	"Strict subset operator."

	self size < aSet size ifFalse: [^false]
		ifTrue: [self do: [:elem | (aSet includes: elem)
					ifFalse: [^false]]].
	^true!

<= aSet 
	"subset operator."

	self size <= aSet size ifFalse: [^false]
		ifTrue: [self do: [:elem | (aSet includes: elem)
					ifFalse: [^false]]].
	^true!

= aSet 
	"Set equality"

	self size = aSet size ifFalse: [^false]
		ifTrue: [self do: [:elem | (aSet includes: elem)
					ifFalse: [^false]]].
	^true!

> aSet 
	"strict super set."

	^aSet < self!

>= aSet 
	"super set."

	^aSet <= self
! !

"COPYRIGHT.
 The above file is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).
 Further information on the copyright conditions may be obtained by
 sending electronic mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1992 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help 
"!
