"
 COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

InspectorView subclass:#StructureInspectorView
	 instanceVariableNames:'keys'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Interface-Inspector'
!

StructureInspectorView  comment:'

COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved

modified Inspector for Structures

written jan 93 by claus
'!

!StructureInspectorView methodsFor:'user interaction'!

doAccept:theText
    "accept value for selected item"

    |value k index|

    value := Compiler evaluate:theText receiver:inspectedObject notifying:workspace.

    selectedLine notNil ifTrue:[
	selectedLine == 1 ifFalse:[
	    inspectedObject perform:(listView selectionValue , ':') asSymbol with:value.
	    inspectedObject changed
	].
    ]
!

doInspect
    "inspect selected item"

    |k index objectToInspect|

    selectedLine notNil ifTrue:[
	selectedLine == 1 ifTrue:[
	    objectToInspect := inspectedObject
	] ifFalse:[
	    objectToInspect := inspectedObject perform:(listView selectionValue) asSymbol 
	].
	objectToInspect inspect
    ]
!

showSelection:lineNr
    "user clicked on an instvar - show value in workspace"

    |val string|

    workspace contents:nil.
    lineNr == 1 ifTrue:[
	val := inspectedObject
    ] ifFalse:[
	val := inspectedObject perform:(listView selectionValue) asSymbol
    ].
    string := val displayString.
    workspace paste:string.
"
    workspace show:string.
"
    selectedLine := lineNr
! !

!StructureInspectorView methodsFor:'accessing'!

fieldList
    "return a list of names for the selectionlist"

    |aList|

    aList := OrderedCollection new.
    inspectedObject class fieldDefinition do:[:def |
	aList add:(def at:1)
    ].
    aList addFirst:'self'.
    ^ aList
! !
